ZFS-REWRITE(8)

NAME
zfs-rewrite - rewrite specified files without modification

SYNOPSIS
zfs rewrite [-Prvx] [-l length] [-o offset] file|directory…

DESCRIPTION
Rewrite blocks of specified file as is without modification at a new location and possibly with new properties, as if they were atomically read and written back. See NOTES. for more information about property changes that may be applied during rewrite.

-P  Perform physical rewrite, preserving logical birth time of blocks. By default, rewrite updates logical birth times, making blocks appear as modified in snapshots and incremental send streams. Physical rewrite preserves logical birth times, avoiding unnecessary inclusion in incremental streams. Physical rewrite requires the physical_rewrite feature to be enabled on the pool.

-l length
    Rewrite at most this number of bytes.

-o offset
    Start at this offset in bytes.

-r  Recurse into directories.

-v  Print names of all successfully rewritten files.

-x  Don't cross file system mount points when recursing.

NOTES
Rewrite works by replacing an existing block with a new block of the same logical size. Changed dataset properties that operate on the data or metadata without changing the logical size will be applied. These include checksum, compression, dedup and copies. Changes to properties that affect the size of a logical block, like recordsize, will have no effect.

Rewrite of cloned blocks and blocks that are part of any snapshots, same as some property changes may increase pool space usage. Holes that were never written or were previously zero-compressed are not rewritten and will remain holes even if compression is disabled.

If a -l or -o value request a rewrite to regions past the end of the file, then those regions are silently ignored, and no error is reported.

By default, rewritten blocks update their logical birth time, meaning they will be included in incremental zfs send streams as modified data. When the -P flag is used, rewritten blocks preserve their logical birth time, since there are no user data changes.

SEE ALSO
zfsprops(7), zpool-features(7)